Index: tmp/org.txm.concordance.core/src/org/txm/concordance/core/functions/Concordance.java
===================================================================
--- tmp/org.txm.concordance.core/src/org/txm/concordance/core/functions/Concordance.java	(revision 541)
+++ tmp/org.txm.concordance.core/src/org/txm/concordance/core/functions/Concordance.java	(revision 542)
@@ -57,6 +57,7 @@
 import org.txm.searchengine.cqp.corpus.Property;
 import org.txm.searchengine.cqp.corpus.QueryResult;
 import org.txm.searchengine.cqp.corpus.StructuralUnit;
+import org.txm.searchengine.cqp.corpus.StructuralUnitProperty;
 import org.txm.searchengine.cqp.corpus.query.Match;
 import org.txm.searchengine.cqp.corpus.query.Query;
 import org.txm.searchengine.cqp.serverException.CqiServerError;
@@ -81,43 +82,121 @@
 	int[] CQLLimitStarts = null;
 
 	/** The lines. */
-	private List<Line> lines;
+	protected List<Line> lines;
 	/** The n lines. */
-	private int nLines;
-
-	String pCQLLimit;
-	/** The keyword analysis property. */
-	private List<Property> pKeywordAnalysisProperties;
+	protected int nLines;
+	/** The keyword analysis properties */
+	protected List<Property> pAnalysisKeywordProperties;
+	/** The analysis properties */
+	protected List<Property> pAnalysisLeftProperties;
+	/** The ReferncePattern sort properties	 */
+	protected ReferencePattern pAnalysisRefPattern;
+	/** The right c analysis property. */
+	protected List<Property> pAnalysisRightProperties;
+	/** used to limit context to the matches of the CQL limit query	 */
+	protected String pLimitCQL;
+	/** The left context size. */
+	protected Integer pLeftContextSize;
+	/** The query. */
+	protected Query pQuery;
+	/** The right context size. */
+	protected Integer pRightContextSize;
+	/**	 The top line index shown and the number of lines to show per page */
+	protected Integer pTopIndex, pNLinesPerPage;
 	/** The keyword view properties. */
-	private List<Property> pKeywordViewProperties;
-	/** The analysis property. */
-	private List<Property> pLeftAnalysisProperties;
-	/** The left context size. */
-	private Integer pLeftContextSize;
+	protected List<Property> pViewKeywordProperties;
 	/** The left c view properties. */
-	private List<Property> pLeftCViewProperties;
-	/** The query. */
-	private Query pQuery;
-	private ReferencePattern pRefAnalysePattern;
+	protected List<Property> pViewLeftProperties;
 	/** The reference pattern. */
-	private ReferencePattern pRefViewPattern;
-	/** The right c analysis property. */
-	private List<Property> pRightAnalysisProperties;
-	/** The right context size. */
-	private Integer pRightContextSize;
+	protected ReferencePattern pViewRefPattern;
 	/** The right c view properties. */
-	private List<Property> pRightCViewProperties;
-	/** The view properties. */
-	private List<Property> pViewProperties; // contains all the view properties
+	protected List<Property> pViewRightProperties;
+	//	/** The view properties. */
+	//	private List<Property> pViewKeywordProperties; // contains all the view properties
 
 	/** The query result. */
 	private QueryResult queryResult;
 	/** The symbol. */
 	private String symbol;
 
-	/** The writer. */
-	private Writer writer;
+	private ArrayList<Property> availableKeywordViewProperties;
 
+	private ArrayList<Property> availableLeftViewProperties;
+
+	private ArrayList<Property> availableRightViewProperties;
+
+	private ArrayList<Property> availableLeftSortProperties;
+
+	private ArrayList<Property> availableKeywordSortProperties;
+
+	private ArrayList<Property> availableRightSortProperties;
+
+	/**
+	 * 
+	 * @param corpus
+	 * @param v
+	 * @return a list of word properties read from a String
+	 */
+	public static List<Property> stringToProperties(Corpus corpus, String v)  {
+
+		ArrayList<Property> props = new ArrayList<Property>();
+		if (v == null) return props;
+		if (v.length() == 0) return props;
+
+		String[] split = v.split("\t");
+		for (String s : split) {
+			Property prop;
+			try {
+				prop = corpus.getProperty(s);
+			} catch (CqiClientException e) {
+				System.out.println("Error: "+v+" property not found in "+corpus);
+				Log.printStackTrace(e);
+				return null;
+			}
+			if (prop != null) {
+				props.add(prop);
+			}
+		}
+		return props;
+	}
+
+	/**
+	 * 
+	 * @param corpus
+	 * @param v
+	 * @return a list of word and structure properties read from a String
+	 */
+	public static ReferencePattern stringToReferencePattern(Corpus corpus, String v) {
+		try {
+			ReferencePattern props = new ReferencePattern();
+			if (v == null) return props;
+			if (v.length() == 0) return props;
+
+			String[] split = v.split("\t");
+			for (String s : split) {
+				if (s.contains("_")) {
+					String[] split2 = s.split("_", 2);
+					StructuralUnit su = corpus.getStructuralUnit(split2[0]);
+					if (su != null) {
+						Property prop = su.getProperty(split2[1]);
+						if (prop != null) {
+							props.addProperty(prop);
+						}
+					}
+				} else {
+					Property prop = corpus.getProperty(s);
+					if (prop != null) {
+						props.addProperty(prop);
+					}
+				}
+			}
+			return props;
+		} catch (Exception e) {
+			System.out.println("Error: "+v+" property not found in "+corpus);
+			return null;
+		}
+	}
+
 	public Concordance(Corpus corpus) {
 
 		super(corpus);
@@ -125,61 +204,94 @@
 		if (corpus != null) {
 			setCQLSeparator(corpus.getCQLLimitQuery());
 		}
+		
+		this.pTopIndex = this.getIntParameterValue(ConcordancePreferences.TOP_INDEX);
+		this.pNLinesPerPage = this.getIntParameterValue(ConcordancePreferences.N_LINE_PER_PAGE);
 
-		// initialize default preference values of this Concordance
-//		try {
-//			this.parameters = new TXMParameters();
-//			this.parameters.put(ConcordancePreferences.QUERY, this.getStringParameterValue(ConcordancePreferences.QUERY));
-//			this.parameters.put(ConcordancePreferences.LEFT_ANALYSIS_PROPERTIES, this.getStringParameterValue(ConcordancePreferences.LEFT_ANALYSIS_PROPERTIES));
-//			this.parameters.put(ConcordancePreferences.KEYWORD_ANALYSIS_PROPERTIES, this.getStringParameterValue(ConcordancePreferences.KEYWORD_ANALYSIS_PROPERTIES));
-//			this.parameters.put(ConcordancePreferences.RIGHT_ANALYSIS_PROPERTIES, this.getStringParameterValue(ConcordancePreferences.RIGHT_ANALYSIS_PROPERTIES));
-//			this.parameters.put(ConcordancePreferences.LEFT_VIEW_PROPERTIES, this.getStringParameterValue(ConcordancePreferences.LEFT_VIEW_PROPERTIES));
-//			this.parameters.put(ConcordancePreferences.KEYWORD_VIEW_PROPERTIES, this.getStringParameterValue(ConcordancePreferences.KEYWORD_VIEW_PROPERTIES));
-//			this.parameters.put(ConcordancePreferences.RIGHT_VIEW_PROPERTIES, this.getStringParameterValue(ConcordancePreferences.RIGHT_VIEW_PROPERTIES));
-//
-//			this.parameters.put(ConcordancePreferences.LEFT_CONTEXT_SIZE, this.getIntParameterValue(ConcordancePreferences.LEFT_CONTEXT_SIZE));
-//			this.parameters.put(ConcordancePreferences.RIGHT_CONTEXT_SIZE, this.getIntParameterValue(ConcordancePreferences.RIGHT_CONTEXT_SIZE));
-//
-//			Property ref = corpus.getProperty("ref");
-//			if (ref != null) {
-//				this.parameters.put(ConcordancePreferences.VIEW_REFERENCEPATTERN, ref);
-//				this.parameters.put(ConcordancePreferences.ANALYSIS_REFERENCEPATTERN, ref);
-//			} else {
-//				this.parameters.put(ConcordancePreferences.VIEW_REFERENCEPATTERN, "text_id");
-//				this.parameters.put(ConcordancePreferences.ANALYSIS_REFERENCEPATTERN, "text_id");
-//			}
-//
-//			this.setParameters(this.parameters);
-//		} catch (CqiClientException e) {
-//			// TODO Auto-generated catch block
-//			e.printStackTrace();
-//		}
+		this.pLeftContextSize = this.getIntParameterValue(ConcordancePreferences.LEFT_CONTEXT_SIZE);
+		this.pRightContextSize = this.getIntParameterValue(ConcordancePreferences.RIGHT_CONTEXT_SIZE);
+
+		this.pLimitCQL = this.getStringParameterValue(ConcordancePreferences.LIMITCQL);
+
+		try {
+			String propertyNames = this.getStringParameterValue(ConcordancePreferences.KEYWORD_VIEW_PROPERTIES);
+			this.pViewKeywordProperties = Concordance.stringToProperties(corpus, propertyNames);
+			this.availableKeywordViewProperties = new ArrayList<Property>(corpus.getOrderedProperties());
+			this.availableKeywordViewProperties.removeAll(pViewKeywordProperties);
+
+			propertyNames = this.getStringParameterValue(ConcordancePreferences.LEFT_VIEW_PROPERTIES);
+			this.pViewLeftProperties = Concordance.stringToProperties(corpus, propertyNames);
+			this.availableLeftViewProperties = new ArrayList<Property>(corpus.getOrderedProperties());
+			this.availableLeftViewProperties.removeAll(pViewLeftProperties);
+
+			propertyNames = this.getStringParameterValue(ConcordancePreferences.RIGHT_VIEW_PROPERTIES);
+			this.pViewRightProperties = Concordance.stringToProperties(corpus, propertyNames);
+			this.availableRightViewProperties = new ArrayList<Property>(corpus.getOrderedProperties());
+			this.availableRightViewProperties.removeAll(pViewRightProperties);
+
+			propertyNames = this.getStringParameterValue(ConcordancePreferences.KEYWORD_ANALYSIS_PROPERTIES);
+			this.pAnalysisKeywordProperties = Concordance.stringToProperties(corpus, propertyNames);
+			this.availableKeywordSortProperties = new ArrayList<Property>(corpus.getOrderedProperties());
+			this.availableKeywordSortProperties.removeAll(pAnalysisKeywordProperties);
+
+			propertyNames = this.getStringParameterValue(ConcordancePreferences.LEFT_ANALYSIS_PROPERTIES);
+			this.pAnalysisLeftProperties = Concordance.stringToProperties(corpus, propertyNames);
+			this.availableLeftSortProperties = new ArrayList<Property>(corpus.getOrderedProperties());
+			this.availableLeftSortProperties.removeAll(pAnalysisLeftProperties);
+
+			propertyNames = this.getStringParameterValue(ConcordancePreferences.RIGHT_ANALYSIS_PROPERTIES);
+			this.pAnalysisRightProperties = Concordance.stringToProperties(corpus, propertyNames);
+			this.availableRightSortProperties = new ArrayList<Property>(corpus.getOrderedProperties());
+			this.availableRightSortProperties.removeAll(pAnalysisRightProperties);
+
+			String refPropertyNames = this.getStringParameterValue(ConcordancePreferences.VIEW_REFERENCEPATTERN);
+			if ("*".equals(refPropertyNames)) {
+				Property refProperty = corpus.getProperty("ref");
+				if (refProperty == null) {
+					StructuralUnitProperty sup_textid = corpus.getTextIdStructuralUnitProperty();
+					this.pViewRefPattern = new ReferencePattern(sup_textid);
+				} else {
+					this.pViewRefPattern = new ReferencePattern(refProperty);
+				}
+			} else {
+				this.pViewRefPattern = Concordance.stringToReferencePattern(corpus, refPropertyNames);
+			}
+			
+			refPropertyNames = this.getStringParameterValue(ConcordancePreferences.ANALYSIS_REFERENCEPATTERN);
+			if ("*".equals(refPropertyNames)) {
+				Property refProperty = corpus.getProperty("ref");
+				if (refProperty == null) {
+					StructuralUnitProperty sup_textid = corpus.getTextIdStructuralUnitProperty();
+					this.pAnalysisRefPattern = new ReferencePattern(sup_textid);
+				} else {
+					this.pAnalysisRefPattern = new ReferencePattern(refProperty);
+				}
+			} else {
+				this.pAnalysisRefPattern = Concordance.stringToReferencePattern(corpus, refPropertyNames);
+			}
+		} catch (CqiClientException e) {
+			// TODO Auto-generated catch block
+			e.printStackTrace();
+		}
 	}
 
-	public void setParameters(Query query,
-			List<Property> selectedLeftCSortProperty,
-			List<Property> selectedRightCSortProperty,
-			List<Property> selectedKeywordSortProperty,
-			List<Property> selectedLeftCViewProperties,
-			List<Property> selectedRightCViewProperties,
-			List<Property> selectedKeywordViewProperties,
-			ReferencePattern referencePattern, 
-			ReferencePattern refAnalysePattern, 
-			Integer leftContextSize,
-			Integer rightContextSize) {
 
-		this.pQuery = query;
-		this.pLeftAnalysisProperties = selectedLeftCSortProperty;
-		this.pRightAnalysisProperties = selectedRightCSortProperty;
-		this.pKeywordAnalysisProperties = selectedKeywordSortProperty;
-		this.pLeftCViewProperties = selectedLeftCViewProperties;
-		this.pRightCViewProperties = selectedRightCViewProperties;
-		this.pKeywordViewProperties = selectedKeywordViewProperties;
-		this.updateViewPropertiesList();
-		this.pRefViewPattern = referencePattern;
-		this.pRefAnalysePattern = refAnalysePattern;
-		this.pLeftContextSize = leftContextSize;
-		this.pRightContextSize = rightContextSize;
+	/**
+	 * Compute concordance.
+	 *
+	 * @return true, if successful
+	 * @throws CqiClientException 
+	 */
+	@Override
+	protected boolean _compute(boolean update) throws Exception {
+		this.queryResult = this.getCorpus().query(pQuery, pQuery.getQueryString()
+				.replace(" ", "_") + "_concordance", true); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
+
+		this.nLines = queryResult.getNMatch();
+		this.lines = new ArrayList<Line>(Collections.nCopies(nLines,
+				(Line) null));// lines are lazily fetched; we force an
+
+		return true;
 	}
 
 	/**
@@ -193,7 +305,6 @@
 		return separator+(str.replace(separator, separator+separator))+separator;
 	}
 
-
 	/**
 	 * As r matrix.
 	 *
@@ -241,46 +352,28 @@
 	}
 
 	@Override
+	public boolean canCompute() {
+		return getCorpus() != null && pQuery != null && pQuery.length() > 0 && !("\"\"".equals(pQuery.getQueryString()));
+	}
+
+	@Override
 	public void clean() {
 		try {
 			if (queryResult != null)	{
 				queryResult.drop();
 			}
-
-			if (writer != null) {
-				this.writer.flush();
-				this.writer.close();
-			}
 		} catch (Exception e) {
 			org.txm.utils.logger.Log.printStackTrace(e);
 		}
 	}
 
 	/**
-	 * Compute concordance.
-	 *
-	 * @return true, if successful
-	 * @throws CqiClientException 
-	 */
-	@Override
-	protected boolean _compute(boolean update) throws Exception {
-		this.queryResult = this.getCorpus().query(pQuery, pQuery.getQueryString()
-				.replace(" ", "_") + "_concordance", true); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
-
-		this.nLines = queryResult.getNMatch();
-		this.lines = new ArrayList<Line>(Collections.nCopies(nLines,
-				(Line) null));// lines are lazily fetched; we force an
-
-		return true;
-	}
-
-	/**
 	 * Gets the analysis property.
 	 *
 	 * @return the analysisProperty
 	 */
 	public List<Property> getAnalysisProperty() {
-		return pKeywordAnalysisProperties;
+		return pAnalysisKeywordProperties;
 	}
 
 	/**
@@ -294,12 +387,30 @@
 
 	@Override
 	public String getDetails() {
-		if (queryResult != null) {
-			return ConcordanceMessages.Concordance_18 + this.getCorpus().getName()
-					+ ": " //$NON-NLS-1$
-					+ queryResult.getQuery().getQueryString();
+
+		if (isDirty()) {
+			return parent.getName();
 		} else {
-			return ConcordanceMessages.Concordance_18 + this.getCorpus().getName();
+			StringBuffer buf = new StringBuffer();
+			buf.append("Concordance:\n"); //$NON-NLS-1$
+			buf.append("\tCorpus: " + this.getCorpus().getName() + "\n"); //$NON-NLS-1$ //$NON-NLS-2$
+			buf
+			.append("\tQuery: " + this.getQuery().getQueryString() + "\n"); //$NON-NLS-1$ //$NON-NLS-2$
+			buf
+			.append("\tLeft Context View property: " + this.getLeftViewProperties() + "\n"); //$NON-NLS-1$ //$NON-NLS-2$
+			buf
+			.append("\tKeyword View property: " + this.getKeywordViewProperties() + "\n"); //$NON-NLS-1$ //$NON-NLS-2$
+			buf
+			.append("\right Context View property: " + this.getRightViewProperties() + "\n"); //$NON-NLS-1$ //$NON-NLS-2$
+			buf
+			.append("\tLeft Context Sort property: " + this.getLeftAnalysisProperties() + "\n"); //$NON-NLS-1$ //$NON-NLS-2$
+			buf
+			.append("\tKeyword Sort property: " + this.getKeywordAnalysisProperties() + "\n"); //$NON-NLS-1$ //$NON-NLS-2$
+			buf
+			.append("\right Context Sort property: " + this.getRightAnalysisProperties() + "\n"); //$NON-NLS-1$ //$NON-NLS-2$
+			buf.append("\tReference View Pattern: " + this.getRefViewPattern() + "\n"); //$NON-NLS-1$ //$NON-NLS-2$
+			buf.append("\tReference Sort Pattern: " + this.getRefAnalysePattern() + "\n"); //$NON-NLS-1$ //$NON-NLS-2$
+			return buf.toString();
 		}
 	}
 
@@ -314,7 +425,7 @@
 	 * @return the analysisProperty
 	 */
 	public List<Property> getKeywordAnalysisProperties() {
-		return pKeywordAnalysisProperties;
+		return pAnalysisKeywordProperties;
 	}
 
 	/**
@@ -346,7 +457,7 @@
 	 * @return the keywordViewProperties
 	 */
 	public List<Property> getKeywordViewProperties() {
-		return pKeywordViewProperties;
+		return pViewKeywordProperties;
 	}
 
 	/**
@@ -355,7 +466,7 @@
 	 * @return the analysisProperty
 	 */
 	public List<Property> getLeftAnalysisProperties() {
-		return pLeftAnalysisProperties;
+		return pAnalysisLeftProperties;
 	}
 
 	/**
@@ -363,7 +474,7 @@
 	 *
 	 * @return the leftContextSize
 	 */
-	public int getLeftContextSize() {
+	public Integer getLeftContextSize() {
 		return pLeftContextSize;
 	}
 
@@ -373,7 +484,7 @@
 	 * @return the leftCViewProperties
 	 */
 	public List<Property> getLeftViewProperties() {
-		return pLeftCViewProperties;
+		return pViewLeftProperties;
 	}
 
 	public List<Line> getLines() throws CqiClientException, IOException, CqiServerError {
@@ -415,10 +526,10 @@
 
 		//		System.out.println("cqllimit="+cql_limit);
 		//		System.out.println("CQLLimitStarts="+CQLLimitStarts);
-		if (pCQLLimit != null && CQLLimitStarts == null) { // initialize text limits
+		if (pLimitCQL != null && CQLLimitStarts == null) { // initialize text limits
 			try {
-				Log.warning("Get CQL limit for query="+pCQLLimit);
-				CQLLimitStarts = this.getCorpus().getStartLimits(pCQLLimit);
+				Log.warning("Get CQL limit for query="+pLimitCQL);
+				CQLLimitStarts = this.getCorpus().getStartLimits(pLimitCQL);
 				if (CQLLimitStarts.length > 0 && CQLLimitStarts[0] != 0) {
 					int[] tmp  = new int[CQLLimitStarts.length + 1];
 					System.arraycopy(CQLLimitStarts, 0, tmp, 1, CQLLimitStarts.length);
@@ -530,35 +641,35 @@
 				Map<Property, List<List<String>>> keywordsViewPropValues = new HashMap<Property, List<List<String>>>();
 				Map<Property, List<List<String>>> leftCtxViewPropValues = new HashMap<Property, List<List<String>>>();
 				Map<Property, List<List<String>>> rightCtxViewPropValues = new HashMap<Property, List<List<String>>>();
-				for (Property property : pLeftCViewProperties) {
+				for (Property property : pViewLeftProperties) {
 					leftCtxViewPropValues.put(property, cqiClient.getData(property, beginingOfLeftCtxPositions,
 							lengthOfLeftCtx));
 				}
-				for (Property property : pRightCViewProperties) {
+				for (Property property : pViewRightProperties) {
 					rightCtxViewPropValues.put(property, cqiClient.getData(property, beginingOfRightCtxPositions,
 							lengthOfRightCtx));
 				}
-				for (Property property : pKeywordViewProperties) {
+				for (Property property : pViewKeywordProperties) {
 					keywordsViewPropValues.put(property, cqiClient.getData(property, beginingOfKeywordsPositions,
 							lengthOfKeywords));
 				}
 
 				// get all analysis property values of all lines
 				HashMap<Property, List<List<String>>> leftCtxAnaPropValues = new HashMap<Property, List<List<String>>>();
-				for(Property p : pLeftAnalysisProperties) {
+				for(Property p : pAnalysisLeftProperties) {
 					leftCtxAnaPropValues.put(p, cqiClient.getData(p, beginingOfLeftCtxPositions, lengthOfLeftCtx));
 				}
 				HashMap<Property, List<List<String>>> keywordsAnaPropValues = new HashMap<Property, List<List<String>>>();
-				for(Property p : pKeywordAnalysisProperties) {
+				for(Property p : pAnalysisKeywordProperties) {
 					keywordsAnaPropValues.put(p, cqiClient.getData(p, beginingOfKeywordsPositions, lengthOfKeywords));
 				}
 				HashMap<Property, List<List<String>>> rightCtxAnaPropValues = new HashMap<Property, List<List<String>>>();
-				for(Property p : pRightAnalysisProperties) {
+				for(Property p : pAnalysisRightProperties) {
 					rightCtxAnaPropValues.put(p, cqiClient.getData(p, beginingOfRightCtxPositions, lengthOfRightCtx));
 				}
 				// get all view reference values of all lines
 				Map<Property, List<List<String>>> refValues = new HashMap<Property, List<List<String>>>();
-				for (Property property : pRefViewPattern) {
+				for (Property property : pViewRefPattern) {
 					refValues.put(property, cqiClient.getData(property, 
 							beginingOfKeywordsPositions,
 							Collections.nCopies(beginingOfKeywordsPositions.size(), 1)));
@@ -566,7 +677,7 @@
 
 				// get all sort reference values of all lines
 				Map<Property, List<List<String>>> refSortValues = new HashMap<Property, List<List<String>>>();
-				for (Property property : pRefAnalysePattern) {
+				for (Property property : pAnalysisRefPattern) {
 					refSortValues.put(property, cqiClient.getData(property, beginingOfKeywordsPositions,
 							Collections.nCopies(beginingOfKeywordsPositions.size(), 1)));
 				}
@@ -599,43 +710,43 @@
 					//worked(1);
 					// get the kth line's analysis property values
 					HashMap<Property, List<String>> lineLeftCtxAnaPropValue = new HashMap<Property, List<String>>();
-					for(Property p : pLeftAnalysisProperties) {
+					for(Property p : pAnalysisLeftProperties) {
 						lineLeftCtxAnaPropValue.put(p, leftCtxAnaPropValues.get(p).get(k));
 					}
 					HashMap<Property, List<String>> lineKeywordsAnaPropValue = new HashMap<Property, List<String>>();
-					for(Property p : pKeywordAnalysisProperties) {
+					for(Property p : pAnalysisKeywordProperties) {
 						lineKeywordsAnaPropValue.put(p, keywordsAnaPropValues.get(p).get(k));
 					}
 					HashMap<Property, List<String>> lineRightCtxAnaPropValue = new HashMap<Property, List<String>>();
-					for(Property p : pRightAnalysisProperties) {
+					for(Property p : pAnalysisRightProperties) {
 						lineRightCtxAnaPropValue.put(p, rightCtxAnaPropValues.get(p).get(k));
 					}
 					// get the kth line's view property values
 					Map<Property, List<String>> lineLeftCtxViewPropValue = new HashMap<Property, List<String>>();
 					Map<Property, List<String>> lineKeywordsViewPropValue = new HashMap<Property, List<String>>();
 					Map<Property, List<String>> lineRightCtxViewPropValue = new HashMap<Property, List<String>>();
-					for (Property property : pLeftCViewProperties) {
+					for (Property property : pViewLeftProperties) {
 						lineLeftCtxViewPropValue.put(property,
 								leftCtxViewPropValues.get(property).get(k));
 					}
-					for (Property property : pRightCViewProperties) {
+					for (Property property : pViewRightProperties) {
 						lineRightCtxViewPropValue.put(property,
 								rightCtxViewPropValues.get(property).get(k));
 					}
-					for (Property property : pKeywordViewProperties) {
+					for (Property property : pViewKeywordProperties) {
 						lineKeywordsViewPropValue.put(property,
 								keywordsViewPropValues.get(property).get(k));
 					}
 
 					// get the kth line reference values
 					Map<Property, String> ref = new HashMap<Property, String>();
-					for (Property property : pRefViewPattern) {
+					for (Property property : pViewRefPattern) {
 						ref.put(property, refValues.get(property).get(k).get(0));
 					}
 
 					// get the kth line reference values
 					Map<Property, String> refAna = new HashMap<Property, String>();
-					for (Property property : pRefAnalysePattern) {
+					for (Property property : pAnalysisRefPattern) {
 						refAna.put(property, refSortValues.get(property).get(k).get(0));
 					}
 
@@ -660,8 +771,8 @@
 							lineKeywordsViewPropValue,
 							lineRightCtxViewPropValue, lineLeftCtxAnaPropValue,
 							lineKeywordsAnaPropValue, lineRightCtxAnaPropValue,
-							new Reference(ref, pRefViewPattern), 
-							new Reference(refAna, pRefAnalysePattern), 
+							new Reference(ref, pViewRefPattern), 
+							new Reference(refAna, pAnalysisRefPattern), 
 							match, 
 							targetpos);
 					lines.set(i + k, line);
@@ -696,7 +807,7 @@
 	 * 
 	 * @return the n lines
 	 */
-	public int getNLines() {
+	public Integer getNLines() {
 		return nLines;
 	}
 
@@ -714,7 +825,7 @@
 	}
 
 	public ReferencePattern getRefAnalysePattern() {
-		return pRefAnalysePattern;
+		return pAnalysisRefPattern;
 	}
 
 	/**
@@ -723,7 +834,7 @@
 	 * @return the referencePattern
 	 */
 	public ReferencePattern getRefViewPattern() {
-		return pRefViewPattern;
+		return pViewRefPattern;
 	}
 
 	/**
@@ -732,7 +843,7 @@
 	 * @return the analysisProperty
 	 */
 	public List<Property> getRightAnalysisProperties() {
-		return pRightAnalysisProperties;
+		return pAnalysisRightProperties;
 	}
 
 	/**
@@ -740,7 +851,7 @@
 	 *
 	 * @return the rightContextSize
 	 */
-	public int getRightContextSize() {
+	public Integer getRightContextSize() {
 		return pRightContextSize;
 	}
 
@@ -750,7 +861,7 @@
 	 * @return the rightCViewProperties
 	 */
 	public List<Property> getRightViewProperties() {
-		return pRightCViewProperties;
+		return pViewRightProperties;
 	}
 
 	@Override
@@ -769,15 +880,6 @@
 	}
 
 	/**
-	 * Gets the view properties.
-	 *
-	 * @return the viewProperties
-	 */
-	public List<Property> getViewProperties() {
-		return pViewProperties;
-	}
-
-	/**
 	 * Gets the line index linked to the global token position in corpus according to the current concordance sorting.
 	 * @param globalPosition
 	 * @return
@@ -859,6 +961,16 @@
 		return index;
 	}
 
+	/**
+	 * reload a part of the concordance lines
+	 * 
+	 * @param topLine
+	 * @param bottomLine
+	 * @return
+	 * @throws CqiClientException
+	 * @throws IOException
+	 * @throws CqiServerError
+	 */
 	public List<Line> reloadLines(int topLine, int bottomLine) throws CqiClientException, IOException, CqiServerError {
 		for (int i = topLine; i < bottomLine; i++) {
 			lines.set(i, null);
@@ -867,6 +979,7 @@
 		return getLines(topLine, bottomLine);
 	}
 
+
 	/**
 	 * Update the QueryResult removing the match of the given line.
 	 * 
@@ -951,6 +1064,13 @@
 		return false;
 	}
 
+	/**
+	 * Brutal way to reset the concordance lines. they will be recomputed when getLines(...) is called
+	 */
+	public void resetLines() {
+		lines = new ArrayList<Line>(Collections.nCopies(nLines,
+				(Line) null)); // empty lines
+	}
 
 	/**
 	 * Set the analysis property.
@@ -958,11 +1078,10 @@
 	 * @param list the new analysis property
 	 */
 	public void setAnalysisProperty(List<Property> list) {
-		this.pLeftAnalysisProperties = list;
-		this.pRightAnalysisProperties = list;
-		this.pKeywordAnalysisProperties = list;
-		this.lines = new ArrayList<Line>(Collections.nCopies(nLines,
-				(Line) null)); // empty lines
+		this.pAnalysisLeftProperties = list;
+		this.pAnalysisRightProperties = list;
+		this.pAnalysisKeywordProperties = list;
+		resetLines();
 	}
 
 	/**
@@ -971,10 +1090,10 @@
 	 * @param list the new analysis property
 	 */
 	public void setAnalysisProperty(List<Property> leftProps, List<Property> keywordProps, List<Property> rightProps) {
-		this.pLeftAnalysisProperties = leftProps;
-		this.pRightAnalysisProperties = keywordProps;
-		this.pKeywordAnalysisProperties = rightProps;
-		this.lines = new ArrayList<Line>(Collections.nCopies(nLines, (Line) null)); // empty lines
+		this.pAnalysisLeftProperties = leftProps;
+		this.pAnalysisRightProperties = keywordProps;
+		this.pAnalysisKeywordProperties = rightProps;
+		resetLines();
 	}
 
 	/**
@@ -984,11 +1103,7 @@
 	 *            the new context size
 	 */
 	public void setContextSize(int size) {
-		this.pLeftContextSize = size;
-		this.pRightContextSize = size;
-		this.lines = new ArrayList<Line>(Collections.nCopies(nLines,
-				(Line) null));// we could make it less radically. But the data
-		// is cached anyway...
+		setContextSize(size,  size);
 	}
 
 	/**
@@ -1000,17 +1115,12 @@
 	public void setContextSize(int leftsize, int rightsize) {
 		this.pLeftContextSize = leftsize;
 		this.pRightContextSize = rightsize;
-		this.lines = new ArrayList<Line>(Collections.nCopies(nLines,
-				(Line) null));// we could make it less radically. But the data
-		// is cached anyway...
+		dirty = true;
 	}
 
 	public void setCQLSeparator(String cql_limit) {
-		if (this.pCQLLimit != null && !this.pCQLLimit.equals(cql_limit)) { 
-			//the CQL limit changed !
-			CQLLimitStarts = null;
-		}
-		this.pCQLLimit = cql_limit;
+		this.pLimitCQL = cql_limit;
+		updateDirty(pLimitCQL, cql_limit);
 	}
 
 	/**
@@ -1020,9 +1130,9 @@
 	 *            the new analysis property
 	 */
 	public void setKeywordAnalysisProperties(List<Property> selectedKeywordSortProperty) {
-		this.pKeywordAnalysisProperties = selectedKeywordSortProperty;
-		this.lines = new ArrayList<Line>(Collections.nCopies(nLines,
-				(Line) null));// we could make it less radically.
+		this.pAnalysisKeywordProperties = selectedKeywordSortProperty;
+		updateDirty(pAnalysisKeywordProperties, selectedKeywordSortProperty);
+		resetLines();
 	}
 
 	/**
@@ -1032,9 +1142,9 @@
 	 *            the new analysis property
 	 */
 	public void setLeftAnalysisProperties(List<Property> selectedLeftSortProperty) {
-		this.pLeftAnalysisProperties = selectedLeftSortProperty;
-		this.lines = new ArrayList<Line>(Collections.nCopies(nLines,
-				(Line) null)); // empty lines
+		this.pAnalysisLeftProperties = selectedLeftSortProperty;
+		updateDirty(pAnalysisLeftProperties, selectedLeftSortProperty);
+		resetLines();
 	}
 
 	/**
@@ -1044,11 +1154,39 @@
 	 */
 	public void setLeftContextSize(int size) {
 		this.pLeftContextSize = size;
-		this.lines = new ArrayList<Line>(Collections.nCopies(nLines,
-				(Line) null));// we could make it less radically. But the data
-		// is cached anyway...
+		updateDirty(pLeftContextSize, size);
+		resetLines();
 	}
 
+
+
+	public void setParameters(Query query,
+			List<Property> selectedLeftCSortProperty,
+			List<Property> selectedRightCSortProperty,
+			List<Property> selectedKeywordSortProperty,
+			List<Property> selectedLeftCViewProperties,
+			List<Property> selectedRightCViewProperties,
+			List<Property> selectedKeywordViewProperties,
+			ReferencePattern referencePattern, 
+			ReferencePattern refAnalysePattern, 
+			Integer leftContextSize,
+			Integer rightContextSize) {
+
+		this.pQuery = query;
+		this.pAnalysisLeftProperties = selectedLeftCSortProperty;
+		this.pAnalysisRightProperties = selectedRightCSortProperty;
+		this.pAnalysisKeywordProperties = selectedKeywordSortProperty;
+		this.pViewLeftProperties = selectedLeftCViewProperties;
+		this.pViewRightProperties = selectedRightCViewProperties;
+		this.pViewKeywordProperties = selectedKeywordViewProperties;
+		this.pViewRefPattern = referencePattern;
+		this.pAnalysisRefPattern = refAnalysePattern;
+		this.pLeftContextSize = leftContextSize;
+		this.pRightContextSize = rightContextSize;
+		
+		this.dirty = true;
+	}
+
 	@Override
 	public boolean setParameters(TXMParameters parameters) {
 
